/* Strip Club - Online/Offline Comic Reader/Archiver
 *
 * Copyright notice for this file:
 *  Copyright (C) 2004 Benjamin Cutler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _URL_H
#define _URL_H 1

#include <FL/Fl_Preferences.H>
#include "interface.h"

#define SCVERSION "Strip Club v0.6.2"
#define USERAGENT "Strip Club/0.6.2"

#ifdef WIN32
#	define README "readme.txt"
#else
#	define README "/usr/doc/stripclub/readme.txt"
#endif

enum eOffType {
	OFFTYPE_OFFLINE = 0,
	OFFTYPE_MISSING,
	OFFTYPE_CHECK
};

extern char *CurComic;
extern Fl_Preferences *Prefs, *CurComicG;
extern cWindow Interface;
extern eOffType Offline;

typedef struct _URL {
	char *Full;
	char *Protocol;
	char *Host;
	char *Port;	
	char *Path;
	char *FullPath;
	char *File;
	char *Extension;
} sURL;

inline void clonestr(const char *src, char **dst, int size = 0) {
	if (size) {
		*dst = new char[size + 1];
		strncpy(*dst, src, size);
		(*dst)[size] = '\0';
	} else {
		*dst = new char[strlen(src) + 1];
		strcpy(*dst, src);
	}
}

// Some system headers define these already (notably windef.h)

#ifndef max
inline int max(int a, int b) {
	return (a > b) ? a : b;
}
#endif

#ifndef min
inline int min(int a, int b) {
	return (a < b) ? a : b;
}
#endif

int URLBreak(const char *URL, sURL *Break);
char *MakeNewURL(const char *New, sURL *Old);
char *URLUnbreak(sURL *Break);
void URLDelete(sURL *URL);

void SwitchComic(Fl_Widget *w, void *New);

#endif
